%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}
  \center{\huge{\bf Exercise: linked list}}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Exercise: Linked Lists}

  \begin{itemize}
    \item What is a linked list?
    \begin{itemize}
      \item Flexible container for data
      \item Size not a priori fixed
      \item Data is stored in linear order (we can iterate over the elements)
    \end{itemize}
    \item Use cases:
    \begin{itemize}
      \item Sparse matrices
      \item In Octopus:
      \begin{itemize}
        \item List of interactions and interaction partners
        \item List of algorithmic steps in propagators
        \item etc.
      \end{itemize} 
    \end{itemize}
  \end{itemize}
  
  \end{frame}
  
  \begin{frame}[fragile] \frametitle{Exercise: Linked Lists: Minimal Implementation}
  
  \begin{columns}
  
  \begin{column}{0.5\textwidth}
    List node:
    \begin{itemize}
      \item Data (private):
      \begin{itemize}
        \item value (here: {\tt integer})
        \item pointer to next node
      \end{itemize}
      \item Methods:
      \begin{itemize}
        \item Constructor
        \item set next
        \item get next
      \end{itemize}
    \end{itemize}
  \end{column}
  
  \begin{column}{0.5\textwidth}
    List:
    \begin{itemize}
      \item Data (private):
      \begin{itemize}
        \item pointer to first node
        \item pointer to last node
        \item size
      \end{itemize}
      \item Methods:
      \begin{itemize}
        \item append value
        \item get first
        \item get size
        \item empty list
      \end{itemize}
    \end{itemize}
  \end{column}
  \end{columns}
  
  \begin{center}
    \begin{tikzpicture}[list/.style={rectangle split, rectangle split parts=2,
      draw, rectangle split horizontal}, >=stealth, start chain]
  
    \node[list,above=1] (L) {List};
    \node[list,on chain] (A) {12};
    \node[list,on chain] (B) {99};
    \node[list,on chain] (C) {37};
    \node[on chain,draw,inner sep=6pt] (D) {};
    \draw (D.north east) -- (D.south west);
    \draw (D.north west) -- (D.south east);
    \draw[*->] let \p1 = (A.two), \p2 = (A.center) in (\x1,\y2) -- (B);
    \draw[*->] let \p1 = (B.two), \p2 = (B.center) in (\x1,\y2) -- (C);
    \draw[*->] let \p1 = (C.two), \p2 = (C.center) in (\x1,\y2) -- (D);
    \draw[*->] let \p1 = (L.two), \p2 = (L.center) in (\x1,\y2) -- (A);
    \draw[*->] let \p1 = (L.two), \p2 = (L.center) in (\x1,\y2) -- (C);
  
    \end{tikzpicture}
  \end{center}
  
  \end{frame}
  
  \begin{frame}[fragile] \frametitle{Exercise: Linked Lists: Small Test}
  
    \begin{itemize}
      \item Define list {\tt my\_list}
      \item Print its size
      \item Add a few values
      \item Print its size again
      \item loop over nodes and print the values
      \item Empty the list
    \end{itemize}
  
  \end{frame}
  
  \begin{frame}[fragile] \frametitle{Exercise: Linked Lists: Small Enhancements}
  
    \begin{itemize}
      \item Add operator (==) to compare two list\_nodes
      \item Add method to {\tt list\_t} to check whether the list contains a given node
    \end{itemize}
  
\end{frame}
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Exercise: Polymorphic Linked Lists}
  
  Change the code so we can store integers and real numbers!
  \begin{itemize}
    \item Create abstract type {\tt list\_node\_t}
    (which data and methods can be included?)
    \item keep overloaded operator as deferred method
    \item create derived types for integer and real values
    \item Change the test code to add some integers and some reals to the list.
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Outlook: Unlimited Polymorphic pointers; Iterators}

  Unlimited Polymorphic Pointers:
  \begin{itemize}
    \item This approach is not ideal.
    \item Better approach (used in Octopus): unlimited polymorphic pointer
    {\small
    \lstset{language=Fortran}
    \begin{lstlisting}
    class(*), pointer :: ptr
    \end{lstlisting}
    }
    \item However, need {\tt select type} for access
  \end{itemize}
  \vspace*{5mm}
  Iterators:
  \begin{itemize}
    \item Traverse through the list
    \item {\tt iterator\%get\_next()}: advance iterator and return current value
    \item Specialized iterators: hide {\tt select type()} inside {\tt get\_next()} function
  \end{itemize}
\end{frame}